"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BasicUseAsyncAuthHook = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const use_async_auth_hook_1 = require("./use-async-auth-hook");
const exampleFn = (a, b, token) => __awaiter(void 0, void 0, void 0, function* () {
    return `${a}_${b}_${token}`;
});
const AuthContext = react_1.default.createContext({ token: 'TOKEN' });
const BasicUseAsyncAuthHook = () => {
    const [hasCalled, setHasCalled] = react_1.default.useState('false');
    const { state, callAuthorized } = (0, use_async_auth_hook_1.useAsyncAuthHook)({
        fn: exampleFn,
        AuthContext,
        callback: (a, b) => setHasCalled(`${a}_${b}`),
    });
    react_1.default.useEffect(() => {
        callAuthorized('Hello', 'world');
    }, []);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("p", null,
            "Value: ",
            react_1.default.createElement("span", null, state.value)),
        react_1.default.createElement("p", null,
            "Has Called: ",
            react_1.default.createElement("span", null, hasCalled))));
};
exports.BasicUseAsyncAuthHook = BasicUseAsyncAuthHook;
exports.BasicUseAsyncAuthHook.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText(`Hello_world_TOKEN`);
    yield react_2.screen.findByText(`Hello_world`);
});
//# sourceMappingURL=use-async-auth-hook.composition.js.map