"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Example = exports.useAsyncAuthHook = void 0;
const react_1 = __importDefault(require("react"));
const useAsyncFn_1 = __importDefault(require("react-use/lib/useAsyncFn"));
const useAsyncAuthHook = ({ callback, fn, AuthContext, }) => {
    const { token } = react_1.default.useContext(AuthContext);
    const [state, call] = (0, useAsyncFn_1.default)(fn);
    const callAuthorized = (...args) => {
        const fullArgs = [...args, token];
        call(...fullArgs).then(() => {
            if (callback)
                callback(...args);
        });
    };
    return {
        callAuthorized,
        submitting: state.loading,
        error: state.error,
        state,
    };
};
exports.useAsyncAuthHook = useAsyncAuthHook;
const Example = () => { };
exports.Example = Example;
//# sourceMappingURL=use-async-auth-hook.js.map